/* Mischt und sortiert Woerterbuecher               */
/* Prueft auf Doppeleintraege                       */
/* neue Version: erzeugt Frequenzeintraege          */ 
/* Version 1 13.3.88 fuer TurboC V1.0 - large mem.  */
/*           strcmp() ersetzt durch my_strcmp()     */
/*           diese Version ist wegen der Umlaute nur*/
/*           fuer den IBM-PC geeignet               */
/* 24.01.92: ueberarbeitet fuer Zortech C++ V3.0    */
/* 18.09.92: 1:1 Filter hinzugefuegt                */
/* 27.07.02: V2.0 ANSI C style adopted              */

 
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define CR   13
#define LF   10

#define LHSH 256
#define CHAR unsigned char

/* Struktur eines WB -Eintrags */
typedef struct entry
{
  CHAR len;
  unsigned freq;
  struct entry *naf;
  unsigned char txt[1];
}   ENTRY;

ENTRY *hsh[LHSH];
char filter_name[120];
int  filter_flag = 0;
int  n,nnv,lwo,hw,iw,dopp,show,gast,iflg,exflg;
int  capitals,freqflag,max_freq;
long anz;
FILE *fd1; 
static CHAR filter[256];


/* Hashtabelle initialisieren */
inihsh(ENTRY *hsh[])
{
int n;
  for (n=0; n < LHSH; n++)
    hsh[n] = NULL;
}   /* end inihsh */

/* read the filter file                          */
/* the file contains entries of the form nnn=mmm */
/* nnn and mmm are decimal codes from 0 to 255   */
int mor_read_filter(char *ifn)
{
int m,n,ic,len,pos;
CHAR item[10],hbuf[100];
FILE *ffil;

  /* preset the filter file */
  for (n=0; n < 256; n++)
    filter[n] = n;

  ffil = fopen(ifn,"r");
  if (ffil == NULL)
  {
    printf("\n--- Filter File not Found ---");
    return(-1);
  }
  filter_flag = 1;
  pos = -1;
  m = 0;

  while (1)
  {
    if (fgets((char *)hbuf,sizeof(hbuf),ffil) == NULL) break;
    if (hbuf[0] == '!') continue;   /* ignore comments */
    if (hbuf[0] == 0x0a) continue;  /* ignore void lines */
    len = strlen((char *)hbuf);
    for (n=0; n < len; n++)
    {
      if (hbuf[n] == ' ') continue;
      if (hbuf[n] == '=')
      {
        item[m] = 0;
        sscanf((char *)item,"%d",&pos);
        if((pos < 0) || (pos >= 256))
        {
          fprintf(stderr,"\n--- wrong filter item %s ---\n",hbuf);
          return(-1);
        }
        m = 0;
        continue;
      } 
      if (hbuf[n] == 0x0a)
      {
        sscanf((char *)item,"%d",&ic);
        if((ic < 0) || (ic >= 256) || (pos < 0))
        {
          fprintf(stderr,"\n--- wrong filter item %s ---\n",hbuf);
          return(-1);
        }
        filter[pos] = ic;
        pos = -1;
        m = 0;
        continue; 
      }
      item[m++] = hbuf[n];
      item[m]   = 0;
    } 
  }
  fclose(ffil);
  return(0);  /* o.k. */
}   /* end mor_read_filter */

void filter_1_1(CHAR *ps)
{
int n;
unsigned pos;
  for (n=0; ps[n] != 0; n++)
  {
    pos = ps[n] & 0xff;
    ps[n] = filter[pos];
  }
}  /* end filter_1_1 */

/* String in Grossbuchstaben uebersetzen */
/* Vorsicht: nicht toupper einsetzen     */
void transl(CHAR *fe)
{
int hc;
  while (*fe != 0)
  {
    if (*fe == LF) break;
    hc = *fe;
    switch (hc)
    {
      case '':
      case '':
        hc = '[';
        break;
      case '':
      case '':
        hc = '\\';
        break;
      case '':
      case '':
        hc = ']';
        break;
      case '':
        hc = '^';
     }
    if ((hc >= 'a') && (hc <= '~'))
       hc -= 32;
    *fe++ = hc;
  }
  *fe = 0;
}   /* end transl */

/* Zeichen in Grossbuchstaben uebersetzen */
CHAR grobu(CHAR c)
{
  c = toupper(c);
  return(c);
}   /* end grobu */

/* strcmp verhaelt sich bei Umlauten nicht korrekt!!! */
int my_strcmp(CHAR *str1, CHAR *str2)
{
int ic;
  while (*str1 != 0)
  {
    ic = *str1++ - *str2++;
    if (ic != 0) return(ic);
  }
  return(0);
}   /* end my_strcmp */

/* akt.Satz in Kette einsortieren */
/* Eliminiert Doppeleintraege     */
void sort(ENTRY *aktp)
{
int iw;
ENTRY *az,*vop;
  az = hsh[aktp->txt[0]];
  if (az == NULL)
  {
    /* neue Kette aufmachen */
    hsh[aktp->txt[0]] = aktp;
    return;
  }
  vop = NULL;
  while (az != NULL)
  {
    /* akt.Satz kleiner als Satz in Kette? */
    iw = my_strcmp(aktp->txt,az->txt);
    if (iw < 0)
    {
      /* Nachf.pointer im Vorg. */
      if (vop != NULL) vop->naf = aktp;
      /* Nachf.pointer im akt. Satz */
      aktp->naf = az;
      /* kleiner als Anfang der Kette? */
      /* dann Hash korrigieren         */
      if (vop == NULL) hsh[aktp->txt[0]] = aktp;
      return;
    }
    if (iw == 0)
    {
        /* Duplikat: Eintrag wieder freigeben  */
        free(aktp);
        anz--;
        dopp++;
        az->freq++;
        if (az->freq > max_freq) max_freq = az->freq;
        return;
    }
    vop = az;
    az  = az->naf;
  }   /* while az != NULL */

  /* Satz ans Ende der Kette haengen */
  if (vop != NULL) vop->naf = aktp;
}  /* end sort */

/* Eintrag (in fe) im WB ablegen */
int stowb(CHAR fe[])
{
int n;
ENTRY *adr;
  n = 0;
  /* n = exakte Laenge berechnen */
  while (fe[n] != 0)
  {
    /* if (fe[n] == ' ') break; */
    if (fe[n] == LF) break;
    if (fe[n] == CR) break;
    n++;
  }
  fe[n] = 0;
  if (n <= 0) return(0);
  /* Ablageformat: Laenge         */
  /*               Nachf.pointer  */
  /*               n Bytes Inhalt */
  adr = (ENTRY *)malloc(sizeof(ENTRY) + n);
  if (adr == NULL)
    return(EOF);
  /* Laenge (ohne Pointer) */
  adr->len = n;
  /* Nachfolgereintrag */
  adr->naf = NULL;
  /* Wortlaut ablegen */
  strcpy((char *)(adr->txt),(char *)fe);
  /* Frequenz */
  adr->freq = 1; 
  /* Satz einsortieren */
  sort(adr);
  return(0);
}   /* end stowb */

main(int argc,
     char *argv[])
{
ENTRY *adr;
int cc,spec_sort,max,n,aflg;
CHAR fe[200];
  printf("\t\t\t----- HUWbsort V2.0 -----\n");
  printf("HUWbsort [-c(apitals)] [-f filterfile]\n");
  printf("Nicht als allgemeines Sortierprogramm verwenden!\n");
  printf("Dont use this as a general sort program!\n");
  inihsh(hsh);
  anz  = 0L;
  dopp = 0;
  capitals = 0;
  max_freq = 0;
  filter_name[0] = 0;

  for (cc=0; cc < argc; cc++)
  {
    if (strcmp(argv[cc],"-c") == 0) capitals = 1;
    if (strcmp(argv[cc],"-f") == 0)
      strcpy(filter_name,argv[cc+1]);
  }
  if (strlen(filter_name) > 0)
    mor_read_filter(filter_name);

  while (1)
  {
    printf("Eingabefile:\n");
    gets((char *)fe);
    if (strlen((char *)fe) == 0) break;
    fd1 = fopen((char *)fe,"r");
    if (fd1 == NULL)
    {
      printf("\n--- nicht gefunden ---");
      continue;
    }

    while (1)
    {
      if (fgets((char *)fe,sizeof(fe),fd1) == NULL) break;
      // 1:1 filter defined?
      if (filter_flag)
        filter_1_1(fe);
      if (capitals)
        transl(fe);        
      if ((++anz % 100) == 0)
         printf("%ld Eintraege\n",anz);
      /* Eintrag sortiert ablegen */
      if (stowb(fe) == EOF)
      {
        fprintf(stderr,"\n--- Speichermangel ---\n");
        break;
      }
    }  /* while (1) */

    fclose(fd1);
  }   /* while 1 */

  /* Jetzt Woerterbuch wieder ausgeben */
  printf("Frequenzen mit ausgeben? J/N:\n");
  gets((char *)fe);
  if (toupper(fe[0]) == 'J') freqflag = 1;
  else                       freqflag = 0;
  printf("nach Frequenzen sortieren? J/N\n");
  gets((char *)fe);
  if (toupper(fe[0]) == 'J') spec_sort = 1;
  else                       spec_sort = 0;
 
  while (1)
  {
    printf("Ausgabefile:\n");
    gets((char *)fe);
    fd1 = fopen((char *)fe,"w");
    if (fd1 == NULL)
    {
      printf("\n--- Dateifehler ---\n");
      continue;
    }

    /* Sortierte Daten ausgeben */
ausg2:
    if (spec_sort) max = max_freq;
    else           max = 1; 
    for (n = max; n > 0; n--)
    {
      for (cc = 0; cc < LHSH; cc++)
      {
        adr = hsh[cc];
        while (adr != NULL)
        {
          aflg = 1;
          if (spec_sort) aflg = (adr->freq == n);
          if (aflg)
          { 
            /* Wortlaut ausgeben */ 
            if (fputs((char *)(adr->txt),fd1) == EOF)
            {
              fclose(fd1);
              printf("\nUeberlauf: Neue Diskette einlegen.Dann Taste\n");
              getchar();
              goto ausg2;
            }
            /* Frequenz ausgegeben*/
            if (freqflag) fprintf(fd1," %d",adr->freq);
            fputc(LF,fd1);
          }   /* if aflg */   
          adr = adr->naf;
        }   /* while adr != NULL */
      }   /* for cc ... */
    }   /* for n.... */
    break;
  }  /* while 1 */

  printf("Anz. Saetze: %ld\n",anz);
  printf("Elim. Doppeleintraege: %d\n",dopp);
  fclose(fd1);

endmain:
  return 0;
}   /* end main */
